var tweets;
var selectedTweet;
var myUsername;
var currentScreenName = "";
var currentUserID = "";
var currentTweetText = "";
var currentTheme = "Dark";
var isLandscape = true;
var isWidget = false;
var width;
var lengthCheck;
var autoRefresh;
var autoRefreshURL = "";
var autoRefreshWidget;
var widgetTweetIndex = -1;
var widgetRefreshCount = 0;
twitter = null;
var geolocation;
var widget;
var append = false;

// Timelines
var HOME_TIMELINE_URL = "https://api.twitter.com/1/statuses/home_timeline.json";	
var PUBLIC_TIMELINE_URL = "https://api.twitter.com/1/statuses/public_timeline.json";
var MENTIONS_TIMELINE_URL = "https://api.twitter.com/1/statuses/mentions.json";
var DIRECT_TIMELINE_URL = "https://api.twitter.com/1/direct_messages.json";
var FAVOURITES_TIMELINE_URL = "https://api.twitter.com/1/favorites.json";
var RETWEETSME_TIMELINE_URL = "https://api.twitter.com/1/statuses/retweets_of_me.json";
var PUBLIC_TIMELINE = "https://api.twitter.com/1/statuses/public_timeline.json";
var RETWEETSTOME_TIMELINE_URL = "https://api.twitter.com/1/statuses/retweeted_to_me.json";
var FRIENDS_TIMELINE_URL = "https://api.twitter.com/1/statuses/friends_timeline.json";
var FOLLOWERS_TIMELINE_URL = "https://api.twitter.com/1/statuses/followers.json";
var USER_TIMELINE_URL = "https://api.twitter.com/1/statuses/user_timeline.json";
var SEARCH_URL = "http://search.twitter.com/search.json";
var LIST_STATUSES_URL = "https://api.twitter.com/1/:user/lists/:id/statuses.json";

function autoFreshWidget() {
	widgetRefreshCount++;
	if(tweets!=null && typeof(tweets)!=undefined && tweets.length>0) {
		if(widgetTweetIndex>15 || tweets.length<widgetTweetIndex) {
			widgetTweetIndex = -1;
		}
		widgetTweetIndex++;
		var tweet = tweets[widgetTweetIndex];
		var tweetDate = parseTwitterDate(tweet.created_at);
		var profileImageUrl = tweet.user.profile_image_url;
		var userName = tweet.user.screen_name;		
		var status = replaceURLWithHTMLLinks(tweet.text);
		
		$("#widgetProfile").html("<img src='" + profileImageUrl + "' width='24' height='24'/>");
		$("#widgetStatus").html(status);
		$("#widgetName").text(userName + " " + prettyDate(tweetDate));
	} else {
		var user = twimStorage.getItem("username"); //.username;
		var pass = twimStorage.getItem("password"); //password;
		if(user!=null && typeof(user)!=undefined && user.length>0) {
			if(twitter!=null && typeof(twitter)!=undefined) {			
				twitter.login(user, pass);	
				autoFresh();
			} else {
				twitter = new Twitter();
				twitter.login(user, pass);	
				autoFresh();
			}
		} else {
			$("#widgetStatus").html("1. Remove this widget<br/>2. Login with TwimGo app<br/>3. Add this widget");
		}
	}
}

function resizeUI() {
	var height = $(window).height();
	width = $(window).width();
	$("#tweetDetails").hide();
	if(width<330) {
		// Widget mode
		isWidget = true;
		autoRefreshURL = HOME_TIMELINE_URL;
		$("body").css("background-color", "transparent");
		$("#loginPage").hide();
		$("#topShadow").hide();
		$("#homePage").hide();
		$("#widgetContent").show();
		clearInterval(autoRefreshWidget);
		autoRefreshWidget = setInterval("autoFreshWidget()", 20000);
		autoFreshWidget();
		return;
	} else {
		/*$("#loginPage").show();
		$("#topShadow").show();
		$("#homePage").show();		*/
		isWidget = false;
	}
	if(width>height) {
		// Landscape
		$("#tweets").css("width", width + "px");
		$(".tweet").css("width", width/2-14 + "px");
		$(".tweet").css("height", "151px");
		//$(".statusText").css("width", width/2-68 + "px");
		$(".status").css("width", width/2-68 + "px");
		$(".break-word").css("max-width", width/2-68 + "px");
		$("#tweetDetails").css("width", width/2-24);
		$("#profilePage").css("width", width/2-24);
		
		// Hide detail fields
		$("#urlField").hide();
		$("#locationField").hide();
		
		$("#buttons").css("left", width-240);		
		$("#buttons").css("width", "240px");
		$(".toolbarButton").css("padding", "0");
		$(".toolbarButton").css("padding-top", "6px");
		isLandscape = true;
	} else {
		// Portrait
		$("#tweets").css("width", width + "px");
		$(".tweet").css("width", width-14 + "px");
		$(".tweet").css("height", "auto");
		//$(".status").css("width", "auto");
		$(".status").css("width", width-68 + "px");
		$(".break-word").css("max-width", width-68 + "px");
		
		//$(".statusText").css("width", "auto");
		$("#tweetDetails").css("width", width-24);
		$("#profilePage").css("width", width-24);
		
		// Reveal detail fields
		$("#urlField").show();
		$("#locationField").show();
		
		$("#buttons").css("left", "0");
		$("#buttons").css("width", width + "px");
		$(".toolbarButton").css("padding-left", "5%");
		$(".toolbarButton").css("padding-right", "5%");
		
		isLandscape = false;		
	}	

	var detailsWidth = parseInt($("#tweetDetails").css("width"));
	$("#closeDetailsButton").css("width", detailsWidth-24 + "px");
	$(".detail").css("width", detailsWidth-24 + "px");
	$(".smalldetail").css("width", ((detailsWidth-24)/2)-12 + "px");
	$(".smallButton").css("width", ((detailsWidth-24)/2)-9 + "px");
	
	var textWidth = parseInt($(".dialog:visible").children("textarea").css("width"));
	/*$(".dialogButton").css("width", textWidth/2 - 21 + "px");*/
	
	$("#tweets").css("min-height", height);
	$("#buttons").css("top", height-60);

	var statusWidth = $(".status").css("width");	
	$(".statusNameAndTime").css("width",statusWidth);
	$(".tweet").css("background-color", "");
}

function checkLength() {
	var len = parseInt($("#newStatus").val().length);
	$("#charsLeft").text(140-len + " ");	
}

function showSearchDialog() {
	$("#nearbyLabel").text("Get your location");
	$("#lat").val("");
	$("#lon").val("");
	$("#searchDialog").slideDown();
	resizeUI();
}

function hideSearchDialog() {
	$("#searchDialog").slideUp();
	resizeUI();
}

function showTweetForm() {
	$("#coordinates").text("Get your location");
	$("#lat").val("");
	$("#lon").val("");
	$("#statusDialog").slideDown();
	lengthCheck = setInterval("checkLength()", 500);
}

function hideTweetForm() {
	$("#statusDialog").slideUp();
	clearInterval(lengthCheck);
}

function bindSearchButtons() {
	$("#cancelSearchButton").click( function() {
		hideSearchDialog();
	});
	
	$("#searchButton").click( function() {
		hideSearchDialog();
		doSearch();
	});
	
	$("#getNearbyButton").click( function() {
		if(geolocation==null && isSymbian==false) {
			$("#nearbyLabel").text("Geolocation is null...");
		} else {
			$("#nearbyLabel").text("Getting location...");
			getLocation();
		}
	});
}

function doSearch(search) {
	$("#pleaseWait").fadeIn();
	var query = search;
	if(search==null || typeof(search)==undefined || search.length==0) {
		query = $("#searchText").val();
	}
	var url = SEARCH_URL + "?q=" + escape(query);
	var lat = $("#lat").val();
	var lon = $("#lon").val();
	if(lat!=null && lat.length>0) {
		url += "&geocode=" + lat + "," + lon + ",20km";
	}
	autoRefreshURL = url;
	twitter.searchTweets(url, parseSearchResults);
}

function parseSearchResults(tweets) {
	doTweets(tweets.results, false);
	if(tweets.results.length>0) {
		var more = createMoreLink(autoRefreshURL);
		$("#moreButton").remove();
		$("#tweets").append(more);
		$("#moreButton").click(function(){
			loadNextPage( this );
		});
	}
	setTimeout("resizeUI()", 10);
	$("#pleaseWait").hide();
}

function bindProfileButtons() {
	$("#directButton").click( function() {
		var tweetText = $("#description").text();
		$("#newStatus").text("");
		$("#replyID").val( "" );
		$("#isDirectTo").val( currentUserID );
		$("#statusUpdateTitle").text("Direct tweet to @" + currentScreenName);
		showTweetForm();
		resizeUI();		
	});
	
	$("#sendButton").click( function() {
		var tweetText = $("#description").text();
		$("#newStatus").text("@" + currentScreenName + " ");
		$("#replyID").val( "" );
		$("#statusUpdateTitle").text("Tweet to @" + currentScreenName);
		showTweetForm();
		resizeUI();		
	});	
	
	$("#userTweetsButton").click( function() {
		var url = USER_TIMELINE_URL + "?user_id=" + currentUserID;
		loadTimeline(url, false);
	});

	$("#followButton").click( function() {
		$("#pleaseWait").fadeIn();
		var labelText = $("#followButtonLabel").text();
		if(labelText=="Follow") {
			twitter.follow(currentUserID, okCallback);
		} else {
			twitter.unfollow(currentUserID, okCallback);
		}
	});
	
}

function loadAndShowSearches() {
	$("#pleaseWait").show();
	try {
		twitter.getSavedSearches(parseSavedSearches);
	} catch(err) {
		$("#leftSearches").text("<li>Error...</li>");
	}
}

function parseSavedSearches(results) {
	try {
		doSavedSearches(results);
	} catch(err) {
		$("#leftSearches").text("<li>Error...</li>");
	}
	$("#pleaseWait").fadeOut();	
}

function doSavedSearches(results) {
	$("#leftSearches").text("");
	$("#rightSearches").text("");
	var searchCount = 0;
	for(var i in results) {
		var saved_search = results[i];
		var htmlBlock = "<li class='savedSearch option ui-corner-all' name='" + saved_search.query + "'>" + saved_search.query + "</li>";
		if(i%2==0) {
			$("#leftSearches").append( htmlBlock );
		} else {
			$("#rightSearches").append( htmlBlock );
		}
		searchCount++;
	}
	if(searchCount>0) {
		$("#savedSearchesDialog").slideDown();
		bindSavedSearchButtons();
	}
}

function bindSavedSearchButtons() {
	$(".savedSearch").click( function() {
		var query = $(this).text();
		$("#savedSearchesDialog").slideUp();
		doSearch(query);
	});	
}

function loadAndShowLists() {
	$("#pleaseWait").show();
	try {
		twitter.getLists(myUsername, parseLists);
	} catch(err) {
		$("#leftLists").text("<li>Error...</li>");
	}
}

function parseLists(results) {
	try {
		doLists(results);
	} catch(err) {
		$("#leftLists").text("<li>Error...</li>");
	}
	$("#pleaseWait").fadeOut();	
}

function doLists(results) {
	$("#leftLists").text("");
	$("#rightLists").text("");
	var lists = results.lists;
	var listCount = 0;
	for(var i in lists) {
		var list = lists[i];
		var htmlBlock = "<li class='tweetList option ui-corner-all' name='" + list.slug + "'>" + list.slug + "</li>";
		if(i%2==0) {
			$("#leftLists").append( htmlBlock );
		} else {
			$("#rightLists").append( htmlBlock );
		}
		listCount++;
	}
	if(listCount>0) {
		$("#listsDialog").slideDown();
		bindListButtons();
	}
}

function bindListButtons() {
	$(".tweetList").click( function() {
		var listID = $(this).text();
		$("#listsDialog").slideUp();
		var url = LIST_STATUSES_URL.replace(":user", myUsername).replace(":id", listID);
		loadTimeline(url, false);
	});	
}

function showSettings() {
	var interval = twimStorage.getItem("refresh"); //.refresh;
	if(interval==null || typeof(interval)==undefined) {
		interval = 5;
	}
	if(interval==0) {
		$("#refreshNever").click();
	} else if(interval==1) {
		$("#refresh1").click();
	} else if(interval==5) {
		$("#refresh5").click();
	} else if(interval==15) {
		$("#refresh15").click();
	} else if(interval==30) {
		$("#refresh30").click();
	}
	
	$("#settingsDialog").slideDown();
}

function switchTheme(theme) {
	if(theme=="Dark") {
		currentTheme = "darkTheme";
		$(".tweet").removeClass("lightTheme");
		$(".tweet").addClass("darkTheme");
	} else {
		currentTheme = "lightTheme";
		$(".tweet").removeClass("darkTheme");
		$(".tweet").addClass("lightTheme");
	}
	twimStorage.setItem("theme", currentTheme);
}

function bindSettingsButtons() {
	$(".refresh").click( function() {
		$(".refresh").removeClass("checked");
		$(".refresh").addClass("unchecked");
		$(this).removeClass("unchecked");
		$(this).addClass("checked");
		
		var interval = $(this).text();
		if(interval=="Never") {
			twimStorage.setItem("refresh", 0); 
		} else if(interval=="1 min") {
			twimStorage.setItem("refresh", 1);
		} else if(interval=="5 min") {
			twimStorage.setItem("refresh", 5);
		} else if(interval=="15 min") {
			twimStorage.setItem("refresh", 15);
		} else if(interval=="30 min") {
			twimStorage.setItem("refresh", 30);
		}
		refreshRefresh();
	})
	
	$(".theme").click( function() {
		$(".theme").removeClass("checked");
		$(".theme").addClass("unchecked");
		$(this).removeClass("unchecked");
		$(this).addClass("checked");
		
		var theme = $(this).text();
		switchTheme(theme);
	})	
	
	$("#saveSettings").click( function() {
		$("#settingsDialog").slideUp();
	});
	$("#cancelSettings").click( function() {
		$("#settingsDialog").slideUp();
	});
}

function showProfile(userID) {
	$("#pleaseWait").show();
	fillProfile(userID);
	$("#profilePage").slideDown();	
	$("#pleaseWait").fadeOut();	
	//$("#tweetDetails").hide();
}

function setUserLocation(position) {
	$("#coordinates").text("Got your location");
	var lat = String(position.coords.latitude);
	var lon = String(position.coords.longitude);
	$("#coordinates").text(lat.substring(0,8) + ", " + lon.substring(0,8));
	$("#nearbyLabel").text("20km near " + lat.substring(0,8) + ", " + lon.substring(0,8));
	$("#lat").val(lat);
	$("#lon").val(lon);
}

function bindButtons() {
	bindProfileButtons();
	bindSearchButtons();
	bindSettingsButtons();
	
	$("#login").click( function() {
		var pass = $("#password").val();
		var user = $("#username").val();
		try {
			twimStorage.setItem("password", pass);
			twimStorage.setItem("username", user);
		} catch(e) {
			// We don't have widget object...
		}
		if(user.length>0 && pass.length>0) {
			login();
		}
	});
	
	$("#exitLoginButton").click( function(){
		window.close();
	});

	$("#homeButton").click( function() {
		loadTimeline(HOME_TIMELINE_URL, false);
	});

	$("#refreshButton").click( function() {
		refreshTweets();
	});
	
	$("#mentionsButton").click( function() {
		loadMentions();
	});	
	
	$("#tweetDetails").click( function() {
		$(".tweet").removeClass("selectedTweet");
		if(isLandscape) {
			$("#tweetDetails").fadeOut();
		} else {
			$("#tweetDetails").slideUp();
		}
	});
	
	$("#cancelStatusButton").click(function(){		
		hideTweetForm();
	});
	
	$("#getLocationButton").click(function(){
		if(geolocation==null && isSymbian==false) {
			$("#coordinates").text("Geolocation is null...");
		} else {
			$("#coordinates").text("Getting location...");
			getLocation();
		}
	});
	
	$("#newStatusButton").click(function(){
		hideTweetForm();
		updateStatus();
	});
	
	$("#commentButton").click( function() {
		$("#newStatus").val( "" );
		$("#replyID").val( "" );
		$("#statusUpdateTitle").text("Status update");
		showTweetForm();
		resizeUI();
	});	
	
	$("#replyButton").click( function() {
		var tweetText = $("#description").text();
		$("#newStatus").text("@" + currentScreenName + " ");
		$("#replyID").val( selectedTweet.id );
		$("#statusUpdateTitle").text("Send reply");
		showTweetForm();
		resizeUI();		
	})
	
	$("#retweetButton").click( function() {
		retweet();
		resizeUI();		
	})

	$("#instantretweetButton").click( function() {
		instantretweet();
		resizeUI();		
	})
	
	$("#profileButton").click( function() {
		$("#pleaseWait").show();
		fillProfile(null);
	});

	$("#showOriginalButton").click( function() {
		$("#pleaseWait").show();
		var inReplyToID = $("#replyTweetID").val();
		twitter.getTweet( inReplyToID, parseSingleTweet );
	});

	$("#starButton").click( function() {
		favourite();
		resizeUI();		
	})
	
	$("#pleaseWait").click( function() {
		hideTweetForm();
	});			
	
	$(".menuAction").click( function() {
		var actionName = $(this).text();
		$("#actionsDialog").slideUp();
		$(window).scrollTop();
		if(actionName=="Home") {
			loadTimeline(HOME_TIMELINE_URL, false);
		} else if(actionName=="Mentions") {
			loadTimeline(MENTIONS_TIMELINE_URL, false);
		} else if(actionName=="Direct") {
			loadTimeline(DIRECT_TIMELINE_URL, false);
		} else if(actionName=="Favourites") {
			loadTimeline(FAVOURITES_TIMELINE_URL, false);
		} else if(actionName=="Retwts of me") {
			loadTimeline(RETWEETSME_TIMELINE_URL, false);
		} else if(actionName=="Public") {
			loadTimeline(PUBLIC_TIMELINE, false);
		} else if(actionName=="Retwts to me") {
			loadTimeline(RETWEETSTOME_TIMELINE_URL, false);
		} else if(actionName=="Friends") {
			loadTimeline(FRIENDS_TIMELINE_URL, false);
		} else if(actionName=="Followers") {
			loadTimeline(FOLLOWERS_TIMELINE_URL, false);
		} else if(actionName=="Search") {
			showSearchDialog();
		} else if(actionName=="Your searches") {
			loadAndShowSearches();
		} else if(actionName=="Lists") {
			loadAndShowLists();
		} else if(actionName=="Settings") {
			showSettings();
		} else if(actionName=="Exit") {
			window.close();
		} else if(actionName=="Logout") {
			twitter.resetToken();
			$("#credentials").show();
			$("#autoLoginLabel").hide();			
			$("#homePage").hide();
			$("#loginFields").show();
			$("#loginPage").show();
		}
	});
	
	$("#profilePage").click( function() {
		$("#profilePage").slideUp();
	});
	
	$("#menuButton").click( function() {
		$("#pleaseWait").hide();
		if($("#actionsDialog").is(":visible")) {
			$("#actionsDialog").slideUp();
		} else {
			$("#actionsDialog").slideDown();
		}
	});

}

function parseSingleTweet(tweet) {
	var tweets = [tweet];
	doTweets(tweets, false);
	setTimeout("resizeUI()", 1);
	$("#pleaseWait").hide();
}

function fillProfile(user) {
	var userID = "";
	try {
		if(user!=null) {
			userID = user;
		} else if(selectedTweet.user!=null && typeof(selectedTweet.user)!=undefined) {
			userID = selectedTweet.user.id;
		} else if(selectedTweet.sender!=null && typeof(selectedTweet.sender)!=undefined) {
			userID = selectedTweet.sender.id;
		} else if(selectedTweet.name!=null && typeof(selectedTweet.name)!=undefined) {
			userID = selectedTweet.id;		
		} else if(selectedTweet.from_user!=null){
			// Search 
			userID = selectedTweet.from_user_id;
		}
		twitter.getUser(userID, parseProfile);
	}catch(e) {
		
	}
}

function parseProfile(user) {
	var name = "";
	var profileImage = "";
	var userLocation = "";
	var statusCount = "-";
	var followerCount = "-";
	var screenName = "";
	var userID = "";
	var url = "";	
	try{
		//var user = $.parseJSON( userJSON );
		name = user.name;
		userID = user.id;
		screenName = user.screen_name;
		profileImage = user.profile_image_url;
		userLocation = user.location;
		url = user.url;
		statusCount = user.statuses_count;
		followerCount = user.friends_count;	
		if(user.following) {
			$("#followButtonLabel").text("Unfollow");
		} else {
			$("#followButtonLabel").text("Follow");
		}
		
		currentScreenName = screenName;
		currentUserID = userID;
		$(".name").text(name);
		$(".location").text(userLocation);
		if(url!=null && url.length>0) {
			$(".url").html("<a href='" + url + "'>" + url.replace("http://", "") + "</a>");
		} else {
			$(".url").html("<a href='http://twitter.com/" + screenName + "'>twitter.com/" + screenName + "</a>");
		}
		$(".statusCount").text(statusCount);
		$(".followerCount").text(followerCount);
		$(".profilePageImage").html("<img src='" + profileImage + "' width='96' height='96' class='ui-corner-all' id='profilePageImg'/>");
		$("#profilePage").slideDown();	
		setTimeout("resizeUI()", 5);
		$("#pleaseWait").hide();
	} catch(err) {
		$(".location").text("Err...");
	}	
}

function favourite() {
	$("#pleaseWait").fadeIn();
	twitter.favourite( selectedTweet.id, okCallback);
}

function retweet() {
	var tweetText = $("#description").text();
	$("#newStatus").text("RT @" + currentScreenName + " " + currentTweetText);
	$("#replyID").val( "" );
	$("#statusUpdateTitle").text("Retweet");
	showTweetForm();
	resizeUI();	
}

function instantretweet() {
	$("#pleaseWait").show();
	twitter.retweet( selectedTweet.id, okCallback );
}

function login() {
	try {
		var theme = twimStorage.getItem("theme");
		if(theme==null || typeof(theme)==undefined) {
			theme = "darkTheme";
		}
	} catch(e) {
		
	}
	currentTheme = theme;
	
	try {
		geolocation = nokia.device.load("geolocation");
	}catch(e) {
		$("#coordinates").text("Error in geolocation...");
	}
	
	// Uncomment next line for debugging purposes
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	}catch(e) {}
	//login2();
	//return;
		
	if(isWidget==false) {
		$("#pleaseWait").show();
		$("#loginPage").hide();
		$("#homePage").show();		
	} else {
		refreshRefresh();
	}
	var username = $("#username").val();
	myUsername = username;
	var password = $("#password").val();
	
	if(typeof(twitter)==undefined || twitter==null) {
		twitter = new Twitter();
	}
	
	$("#progress").append("..");
	twitter.login(username, password);
}

function autoFresh() {
	if( $("#tweetDetails").is(":visible")==false &&
		$("#profilePage").is(":visible")==false &&
		$("#statusDialog").is(":visible")==false &&
		$("#searchDialog").is(":visible")==false &&
		$("#actionsDialog").is(":visible")==false &&
		$("#listsDialog").is(":visible")==false &&
		$("#pleaseWait").is(":visible")==false ) {
		loadTimeline(autoRefreshURL,false);
	}
}

function getLocation() {
	
    // Obtain the Location service object
    try {
		try {
			geolocation.getCurrentPosition(setUserLocation);			
		} catch(e) {
	        var serviceObj = device.getServiceObject("Service.Location", "ILocation");

		    // We are interested in basic location information (longitude, latitude
		    // and altitude) only, so let's define the criteria respectively
		    var criteria = new Object();
		    criteria.LocationInformationClass = "BasicLocationInformation";
 
		    // Obtain the location information (synchronous)
		    var result = serviceObj.ILocation.GetLocation(criteria);
		    var lat = String(result.ReturnValue.Latitude);
		    var lon = String(result.ReturnValue.Longitude);
		
			$("#coordinates").text(lat.substring(0,7) + ", " + lon.substring(0,7));
			$("#nearbyLabel").text(lat.substring(0,7) + ", " + lon.substring(0,7));
			$("#lat").val(lat);
			$("#lon").val(lon);
 		}
	} catch (ex) {
	    return;
	}
}

function refreshRefresh() {
	try {
		var interval = twimStorage.getItem("refresh");
		if(interval==null || typeof(interval)==undefined) {
			interval = 5;
		}
		if(isWidget) {
			autoRefreshURL = HOME_TIMELINE_URL;
			interval = 15;
		}
		interval = parseInt(interval);
		clearInterval(autoRefresh);
		if(interval>0) {
			autoRefresh = setInterval("autoFresh()", interval*60000);
		}
	} catch(e) {
		// We don't have widget object...
	}	
}

function loadTimeline(timelineUrl, appendFully) {
	append = appendFully;
	if(append==false) {
		scroll(0,0);
		autoRefreshURL = timelineUrl;
		refreshRefresh();
	}
	if(!isWidget) {
		$("#pleaseWait").show();
	}
	$("#progress").append("..");
	twitter.getTweets(timelineUrl, parseRealTweets);
}

function parseRealTweets(tweets) {
	var realTweets = tweets;
	if(typeof(realTweets)==undefined) {
		$("#tweets").append("Error parsing tweets:" + tweets);
		return;		
	}
	if(realTweets!=null && realTweets.results!=null) {
		// Get search results
		realTweets = realTweets.results;
	}
	if(realTweets.length>0 && 
		(
			(typeof(tweets)!=undefined && tweets.length>0 && tweets[0].id!=realTweets[0].id) || 
		 	(typeof(tweets)==undefined||tweets!=null||tweets.length==0)
		)) {
		doTweets(realTweets);
		if(realTweets.length>0) {
			var more = createMoreLink(autoRefreshURL);
			$("#moreButton").remove();
			$("#tweets").append(more);
			$("#moreButton").click(function(){
				loadNextPage( this );
			});
		}
		setTimeout("resizeUI()", 25);
	}
	if(!isWidget) {
		$("#pleaseWait").hide();	
	}
	$("#progress").text("");
}

function refreshTweets() {
	var url = $("#nextPageUrl").val();
	if(url!=null) {
		url = url.replace("page=", "somepage=");
	} else {
		url = HOME_TIMELINE_URL;
	}
	loadTimeline(url,false);
}

function loadNextPage(pageButton) {
	var url = $("#nextPageUrl").val();
	$("#moreButton").text("Loading...");
	loadTimeline(url,true);
}

function createMoreLink(url) {
	var newUrl = url;
	var currentPage = parseParameter(url, "page")
	if(typeof(currentPage)!=undefined && currentPage.length>0) {
		var newPage = parseInt(currentPage) + 1;
		newUrl = newUrl.replace("page=" + currentPage, "page=" + newPage);
	} else {
		newUrl += "?page=2";
	}
	var moreButton = "<div id='moreButton'><input id='nextPageUrl' type='hidden' value='" + newUrl + "'/>More</div>";
	return moreButton;
}

function updateStatus() {
	scroll(0,0);
	$("#pleaseWait").fadeIn();
	var status = $("#newStatus").val();
	var lat = $("#lat").val();
	var lon = $("#lon").val();
	var replyID = $("#replyID").val();	
	var isDirectTo = $("#isDirectTo").val();
	var tweet;
	if(isDirectTo!=null && typeof(isDirectTo)!=undefined && isDirectTo.length>0) {
		twitter.directTweet(status, isDirectTo, okCallback);
	} else {
		twitter.updateStatus(status, replyID, lat, lon, okCallback);
	}
	$("#replyID").val( "" );
	$("#isDirectTo").val( "" );	
}

function convertTweetToHtml(tweet) {
	var markup = "";
	try {
		var tweetDate = parseTwitterDate(tweet.created_at);
		var isoDate = tweetDate.toString("yyyy-MM-ddThh:mm:ssZ");
		var status = "";
		var inReplyTo = "";
		var inReplyToID = "";
		var retweeted = "";
		if(tweet.text!=null) {
			status = replaceURLWithHTMLLinks(tweet.text);
			inReplyTo = tweet.in_reply_to_screen_name;
			if(tweet.retweeted_status!=null) {
				retweeted = " retweeted " + tweet.retweeted_status.user.screen_name;
			}
		} else {
			// Friends
			status = replaceURLWithHTMLLinks(tweet.status.text);
			inReplyTo = tweet.status.in_reply_to_screen_name;
			tweetDate = parseTwitterDate(tweet.status.created_at);
		}
		var replyBlock = "";
		if(inReplyTo!=null && typeof(inReplyTo)!=undefined && inReplyTo.length>0) {
			replyBlock = " in reply to @" + inReplyTo;
		}
		var profileImageUrl = "";
		var userName = "";
		if(tweet.user!=null && typeof(tweet.user)!=undefined) {
			// Home, Mentions, Favourites etc.
			profileImageUrl = tweet.user.profile_image_url;
			userName = tweet.user.screen_name;
		} else if(tweet.sender!=null && typeof(tweet.sender)!=undefined) {
			// Direct Tweets
			profileImageUrl = tweet.sender.profile_image_url;
			userName = tweet.sender.screen_name;
		} else if(tweet.name!=null) {
			// Friends 
			userName = tweet.screen_name;
			profileImageUrl = tweet.profile_image_url;
		} else if(tweet.from_user!=null){
			// Search 
			userName = tweet.from_user;
			profileImageUrl = tweet.profile_image_url;
		}
		markup = "<div class='tweet " + currentTheme + "'>" + 
			"<div class='profileImage'><img src='" + profileImageUrl + "' class='ui-corner-all' width='48' height='48'/></div>" + 
			"<div class='status'><div class='statusText'>" + status + "</div><br/></div>" + 
			"<div class='statusNameAndTime'><span class='statusName'>" + userName + replyBlock + retweeted + "</span>&nbsp;" +
			"<span class='statusTime'>" + prettyDate(tweetDate) + "</span></div>" + 
			"</div>";
	} catch(err) {
		markup = "<div class='tweet'>" + err + "</div>"  
	}
	return markup;	
}

function prependTweet(tweet) {
	tweets.splice(0,0,tweet);
	$("#tweets").prepend(convertTweetToHtml(tweet));	
	setTimeout("resizeUI()", 10);
}

function okCallback(data) {
	$("#pleaseWait").hide();
	$("#doneIndicator").fadeIn().delay(500).fadeOut();
}

function errorCallback(data) {
	$("#pleaseWait").hide();
	$("#errorIndicator").fadeIn().delay(2500).fadeOut();
}

function replaceURLWithHTMLLinks(text) {
	try {
		if(typeof(text)==undefined || text==null) {
			return;
		}
		var txt = text.replace(/(#(\w+))/g, "<a href='#' onclick='javascript:doSearch(\"#$2\");'><span class='break-word'>#$2</span></a>");
		txt = txt.replace(/(@(\w+))/g, "<a href='#' onclick='javascript:showProfile(\"$2\");'><span class='break-word'>@$2</span></a>");
		var exp = /(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/ig;
		if(isSymbian) {
			txt = txt.replace(exp,"<a href='javascript:widget.openURL(\"$1\")'><div class='break-word'>$1</div></a>"); 
		} else {
			txt = txt.replace(exp,"<a href='$1'><div class='break-word'>$1</div></a>"); 
		}
		txt = txt.replace(/(<\/a> <a)/g, "</a>&nbsp; <a ");
		return txt.replace(/(<\/a><a)/g, "</a>&nbsp; <a ");
	} catch(err) {
		return text;
	}
}

window.doTweets = function(data) {
	if(typeof(data.results)!=undefined && data.results!=null) {
		// Get search results
		data = data.results;
	}
	if(append==true) {
		tweets = tweets.concat( data );
	} else {
		$("#tweets").text("");
		tweets = data;
	}
	var tweetsHtml = "";
	for(var x in data) {
		var tweet = data[x];
		tweetsHtml += convertTweetToHtml(tweet);
	}
	$("#tweets").append( tweetsHtml );
	
	$(".tweet").unbind("click");
	$(".tweet").click( function() {
		if($(this).hasClass("selectedTweet")) {
			$(".tweet").removeClass("selectedTweet");
			if(isLandscape) {
				$("#tweetDetails").fadeOut();
			} else {
				$("#tweetDetails").slideUp();
			}
			$("#starButton").show();
			return;
		}
		$(".tweet").removeClass("selectedTweet");
		
		var offset = $(this).offset();//.css("left");
		if(offset.left>0 || isLandscape==false) {
			$("#tweetDetails").css("left", "0");
			if(isLandscape) {
				$("#profilePage").css("left", width/2);
			} else {
				$("#profilePage").css("left", "0");
			}
		} else {
			$("#tweetDetails").css("left", width/2);
			$("#profilePage").css("left", "0");
		}
		
		if($("#profilePage").is(":visible")) {
			return;
		}
		$(this).addClass("selectedTweet");
		
		if(isLandscape) {
			if(isSymbian) {
				$("#starButton").hide();
			}
			$("#tweetDetails").fadeIn();
		} else {
			$("#starButton").show();
			$("#tweetDetails").slideDown();
		}
				
		var tweetIndex = $(this).index();
		selectedTweet = tweets[tweetIndex];
		
		var name = "";
		var userName = "";
		var location = "";
		var url = "";
		var statusCount = "";
		var followerCount = "";
		var inReplyToID = "";
		
		$("#name").html("");
		$("#tweetAge").html("");
		$("#location").html("");
		$("#tweetID").html("");
		$("#description").html("");
		$("#url").html("");
		$("#statusCount").text("");
		$("#followerCount").text("");
		$("#replyTweetID").val("");
		
		inReplyToID = selectedTweet.in_reply_to_status_id;
		if(inReplyToID!=null && typeof(inReplyToID)!=undefined) {
			$("#replyTweetID").val( inReplyToID );
			$("#showOriginalButton").show();
		} else {
			$("#showOriginalButton").hide();
		}
		
		if(selectedTweet.user!=null && typeof(selectedTweet.user)!=undefined) {
			name = selectedTweet.user.name;
			currentScreenName = selectedTweet.user.screen_name;
			location = selectedTweet.user.location;
			url = selectedTweet.user.url;
			statusCount = selectedTweet.user.statuses_count;
			followerCount = selectedTweet.user.friends_count;
		} else if(selectedTweet.sender!=null && typeof(selectedTweet.sender)!=undefined) {
			name = selectedTweet.sender.name;
			currentScreenName = selectedTweet.sender.screen_name;
			location = selectedTweet.sender.location;
			url = selectedTweet.sender.url;
			statusCount = selectedTweet.sender.followers_count;
			followerCount = selectedTweet.sender.friends_count;
		} else if(selectedTweet.name!=null && typeof(selectedTweet.name)!=undefined) {
			name = selectedTweet.name;
			currentScreenName = selectedTweet.screen_name;
			location = selectedTweet.location;
			url = selectedTweet.url;
			statusCount = selectedTweet.statuses_count;
			followerCount = selectedTweet.friends_count;
		} else if(selectedTweet.from_user!=null){
			// Search 
			userID = selectedTweet.from_user_id;
			userName = selectedTweet.from_user;
			screenName = userName;
			name = screenName;
			currentScreenName = name;
			profileImage = selectedTweet.profile_image_url;
		} else {
			currentScreenName = "";
		}
		if(selectedTweet.text!=null) {
			currentTweetText = selectedTweet.text;
		} else {
			currentTweetText = selectedTweet.status.text;
		}
		
		if(selectedTweet.source!=null) {
			$("#name").html( currentScreenName + " from " + $("<div/>").html(selectedTweet.source).text() );
		} else {
			$("#name").text( currentScreenName );
		}
		$("#tweetAge").text( parseTwitterDate(selectedTweet.created_at).toString("yyyy-MM-dd HH:mm") );
		$("#location").text( location );
		$("#tweetID").html( selectedTweet.id );
		
		var previewImageHTML = createPreviewImageHTML(currentTweetText);
		if(previewImageHTML!=null && previewImageHTML.length>0) {
			$("#description").html( previewImageHTML );
		} else {
			$("#description").html( replaceURLWithHTMLLinks(currentTweetText) );
		}
		
		$("#url").html( replaceURLWithHTMLLinks(url) );
		$("#statusCount").text( statusCount );
		$("#followerCount").text( followerCount );
	});	
};

function createPreviewImageHTML(text) {
	var html = "";
	var imgSize = "160";
	if(isLandscape==false) {
		imgSize = "240";
	}
	if(text.indexOf("http://twitpic.com/")>=0) {
		var imageID = text.substr(text.indexOf("http://twitpic.com/")+19, 6);
		var url = "http://twitpic.com/show/thumb/" + imageID;
		html = "<center><a href='http://twitpic.com/" + imageID + "'><img src='" + url + "' height='" + imgSize + "' width='" + imgSize + "' /></a></center>";
	} else if(text.indexOf("http://yfrog.com/")>=0) {
		var url = "";
		var linkStart = text.indexOf("http://yfrog.com/");
		var linkEnd = text.indexOf(" ", linkStart);
		var yfrogURL = "";
		if(linkEnd<0) {
			yfrogURL = text.substring(linkStart);
		} else {
			yfrogURL = text.substring(linkStart,linkEnd);
		}
		url = yfrogURL + ".th.jpg";
		html = "<center><a href='" + yfrogURL + "'><img src='" + url + "' height='" + imgSize + "' /></a></center>";
	}
	return html;
}

window.doFailure = function(data) {
	$("#tweets").text("Failure");
};

// Takes an ISO time and returns a string representing how
// long ago the date represents.
// 2008-01-28T20:24:17Z
function prettyDate(date){
	try {
		var	diff = (((new Date()).getTime() - date.getTime()) / 1000),
			day_diff = Math.floor(diff / 86400);
				
		if ( isNaN(day_diff) || day_diff < 0 || day_diff >= 31 ) {
			return time;
		}
				
		return day_diff == 0 && (
				diff < 60 && "just now" ||
				diff < 120 && "1 minute ago" ||
				diff < 3600 && Math.floor( diff / 60 ) + " minutes ago" ||
				diff < 7200 && "1 hour ago" ||
				diff < 86400 && Math.floor( diff / 3600 ) + " hours ago") ||
			day_diff == 1 && "Yesterday" ||
			day_diff < 7 && day_diff + " days ago" ||
			day_diff < 31 && Math.ceil( day_diff / 7 ) + " weeks ago";
			day_diff >= 31 && Math.ceil( day_diff / 30 ) + " months ago";
	} catch(err) {
		return "some time ago";
	}
}

// pass in the 'created_at' string returned from twitter //
// stamp arrives formatted as Tue Apr 07 22:52:51 +0000 2009 //
function parseTwitterDate(stamp)
{		
	try {
		var parts = stamp.split(" ");
		var monthName = parts[1];
		var day = parseInt(parts[2]);
		var time = parts[3].split(":");
		var hours = parseInt(time[0]);
		var minutes = parseInt(time[1]);
		var seconds = parseInt(time[2]);
		var year = parseInt(parts[5]);
		var offset = parts[4];
		
		console.log("offset" + offset);
		
		var month = 
			monthName=="Jan" && 0 ||
			monthName=="Feb" && 1 ||
			monthName=="Mar" && 2 ||
			monthName=="Apr" && 3 ||
			monthName=="May" && 4 ||
			monthName=="Jun" && 5 ||
			monthName=="Jul" && 6 ||
			monthName=="Aug" && 7 ||
			monthName=="Sep" && 8 ||
			monthName=="Oct" && 9 ||
			monthName=="Nov" && 10 ||
			monthName=="Dec" && 11;
			
		var dt = new Date();//year, month, day, hours, minutes, seconds);
		dt.setUTCDate(day);
		dt.setYear(year);
		dt.setUTCMonth(month);
		dt.setUTCHours(hours);
		dt.setUTCMinutes(minutes);
		dt.setUTCSeconds(seconds);
		return dt;
		
		// convert to local string and remove seconds and year //		
		var date = new Date(Date.parse(stamp));//.toLocaleString().substr(0, 16);
		return date;
	} catch(err) {
		return new Date();
	}
}
