var TwimGoStorage = function(){
	
	this.setItem = function(key, value) {
		try {
			// Symbian
			widget.setPreferenceForKey(value, key);
		}catch(e) {
			// HTML5
			localStorage.setItem(key, value);
		}
	}
	
	this.getItem = function(key) {
		try {
			// Symbian
			return widget.preferenceForKey(key);
		}catch(e) {
			// HTML5
			return localStorage.getItem(key);
		}
	}
	
};